lm.component('homeBoxThings', {
	templateUrl: 'components/homeBoxThings.html',
	bindings: {
		box: '<'
	},
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
		
		ctrl.error = null;
		ctrl.items = [];
		
		if(ctrl.box.type != 'thingsBox') return;
		
		$http.get(lmBase.url + 'iot/items',{params : {'hideOwn':ctrl.box.hideOwn, 'hideForeign':ctrl.box.hideForeign}})
		.success(function(data) {
			for(x in data) {
				var it = data[x];
				if(it.type == 'CONTROL_SELECT') {
					for(y in it.options) {
						var option = it.options[y];
						if(it.last && it.last.val == option.key) {
							it.selectedOption = option; 
						}
					}
				}
			}					
			ctrl.items = data;
		}).error(serviceLimboMedia.handleHttpError);
		
		ctrl.controlDoFire = function(con) {
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', {})
				.success(function(data) {
					serviceNotification.ok('DONE');
					con.last = data;
				}).error(serviceLimboMedia.handleHttpError);		
		};
		ctrl.controlDoSwitch = function(con, valOn) {
			var req = {val: valOn};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req)
				.success(function(data) {
					con.last = data;
				}).error(serviceLimboMedia.handleHttpError);		
		};

		ctrl.controlDoSelect = function(con, valOn) {
			var req = {val: valOn.key};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req)
				.success(function(data) {
					serviceNotification.ok('DONE');
					con.last = data;
				}).error(serviceLimboMedia.handleHttpError);		
		};

		ctrl.onPercentSliderChange = function(con, val) {
			var req = {'val': val};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req)
				.success(function(data) {
					serviceNotification.ok('DONE');
					con.last = data;
			}).error(serviceLimboMedia.handleHttpError);		
		}
		
		ctrl.controlDoNumber = function(con) {
			if(!(con.last && con.last.val))
				return;
			
			var req = {val: con.last.val};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req)
				.success(function(data) {
					serviceNotification.ok('DONE');
					con.last = data;
				}).error(serviceLimboMedia.handleHttpError);		
		};

		ctrl.controlDoString = function(con) {
			if(!(con.last && con.last.val))
				return;
			var req = {val: con.last.val};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req)
				.success(function(data) {
					serviceNotification.ok('DONE');
					con.last = data;
				}).error(serviceLimboMedia.handleHttpError);		
		};		
		
		
	}
});