lm.component('homeBoxTodo', {
	templateUrl: 'components/homeBoxTodo.html',
	bindings: {
		box: '<'
	},
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
		
		ctrl.error = null;
		ctrl.items = [];
		
		if(ctrl.box.type != 'todoBox') return;
		
		ctrl.loadItems = function() {
			$http.get(lmBase.url + 't/items/list',{params : {lid:ctrl.box.labelID}})
			.success(function(data) {
				ctrl.items = data;
			})
			.error(function(data, status, headers, config) {
				ctrl.error = "Error fetching todos. Label has been deleted or access denied.";
			});
		}

		ctrl.itemCreateName = '';

		ctrl.itemCreate = function() {
			var req = {name: ctrl.itemCreateName, labelId: ctrl.box.labelID};
			$http.post(lmBase.url + 't/item',req)
				.success(function(data) {
					ctrl.itemCreateName = '';
					ctrl.loadItems();
				}).error(serviceLimboMedia.handleHttpError);
		}
		
		ctrl.itemToggle = function(valueItem) {
			$http.post(lmBase.url + 't/item/' + valueItem.id + '/toggle',!valueItem.done)
			.success(function(data) {
				valueItem.done = !valueItem.done;
			}).error(serviceLimboMedia.handleHttpError);	
		};
		
		ctrl.loadItems();
	}
});