lm.component('lmDateRange', {
  templateUrl: 'components/lmDateRange.html',
  bindings: {
	  daterange: '<',	// {from: moment(), to: moment() }
	  onChange: '&'		// onChange callback
  },
  controller: function($scope, $element, $http, $translate, $modal,serviceLimboMedia,serviceNotification) {
	  var ctrl = this;
	  
	  ctrl.$onInit = function() {
		  $translate(['SAVE', 'CANCEL', 'CUSTOM', 'DEFAULT', 'RANGE_LAST_HOUR', 'RANGE_LAST_DAY', 'RANGE_LAST_WEEK', 'RANGE_LAST_MONTH', 'RANGE_LAST_YEAR', 'RANGE_ALL']).then(function (translations) {
				var rgs = new Object();
				rgs[translations.DEFAULT] = [ ctrl.daterange.from, ctrl.daterange.to ];
				rgs[translations.RANGE_LAST_HOUR] = [ moment().subtract(1,'hour'), ctrl.daterange.to ];
				rgs[translations.RANGE_LAST_DAY] = [moment().subtract(1, 'days'), ctrl.daterange.to];
				rgs[translations.RANGE_LAST_WEEK] = [moment().subtract(1, 'weeks'), ctrl.daterange.to];
				rgs[translations.RANGE_LAST_MONTH] = [moment().subtract(1, 'months'), ctrl.daterange.to];
				rgs[translations.RANGE_LAST_YEAR] = [moment().subtract(1, 'years'), ctrl.daterange.to];
				rgs[translations.RANGE_ALL] = [moment().subtract(100, 'years'), ctrl.daterange.to];

				var el = $($element).find('.thedatepickr');
				el.daterangepicker({
			    	timePicker24Hour: true,
			        timePicker: true,
			        timePickerIncrement: 10,
			        locale: {
			        	format: 'YYYY-MM-DD HH:mm',
			        	cancelLabel: translations.CANCEL,
			        	applyLabel: translations.SAVE,
			        	customRangeLabel: translations.CUSTOM
			        },
			        ranges: rgs,
			        startDate: rgs[translations.DEFAULT][0],
			        endDate: rgs[translations.DEFAULT][1]
			    });
				el.on('apply.daterangepicker', function(ev, picker) {
					$scope.$apply(function() {
						ctrl.daterange.from = picker.startDate;
						ctrl.daterange.to = picker.endDate;
						ctrl.onChange();
						
					});
				});
			});		
		  
	  }
	  
  }
});