lm.component('mediaPlaylist', {
	templateUrl: 'components/mediaPlaylist.html',
	bindings: { },
	controller: function($scope, $http, serviceNotification, serviceLimboMedia, serviceMediaPlayer, serviceFullscreen) {
		var ctrl = this;
		
		ctrl.state = serviceMediaPlayer.state;
		ctrl.pl = serviceMediaPlayer.pl;

		/* controls */
		ctrl.onPrev = function() {
			serviceMediaPlayer.playPrev();
		};
		ctrl.onNext = function() {
			serviceMediaPlayer.playNext();
		};
		ctrl.onPlayPause = function() {
			serviceMediaPlayer.playPause();
		}
		ctrl.onToggleRandom = function() {
			ctrl.pl.random = !ctrl.pl.random;
		};
		ctrl.onToggleRepeat = function() {
			if(ctrl.pl.repeat) {
				if(ctrl.pl.repeatOne) ctrl.pl.repeat = false;
				else ctrl.pl.repeatOne = true;
			}
			else {
				ctrl.pl.repeat = true;
				ctrl.pl.repeatOne = false;
			}
		};
		
		/* playlists load and save */
		ctrl.onPlaylistLoad = function(pl) {
			serviceMediaPlayer.playlistLoad(pl,true);
		};
		ctrl.onPlaylistSave = function() {
			serviceMediaPlayer.playlistSave();
		};
		ctrl.onPlaylistDelete = function() {
			serviceMediaPlayer.playlistDelete(ctrl.pl.playlist);
		};
		
		/* playlist */
		ctrl.playIndex = function(valueIdx) {
			serviceMediaPlayer.playIndex(valueIdx);
		}
		ctrl.playlistUp = function(valueIndex) {
			if(valueIndex < 1) return;
			var temp = ctrl.pl.playlist.items[valueIndex];
			ctrl.pl.playlist.items[valueIndex] = ctrl.pl.playlist.items[valueIndex - 1];
			ctrl.pl.playlist.items[valueIndex - 1] = temp;
			serviceMediaPlayer.playlistOnChange();
		};
		ctrl.playlistDown = function(valueIndex) {
			if(valueIndex >= (ctrl.pl.playlist.items.length - 1)) return;
			
			var temp = ctrl.pl.playlist.items[valueIndex];
			ctrl.pl.playlist.items[valueIndex] = ctrl.pl.playlist.items[valueIndex + 1];
			ctrl.pl.playlist.items[valueIndex + 1] = temp;
			serviceMediaPlayer.playlistOnChange();
		};

		ctrl.playlistAway = function(valueIndex) {
			ctrl.pl.playlist.items.splice(valueIndex,1);
			serviceMediaPlayer.playlistOnChange();
		};
		
		
		
	}
});
