lm.component('noteList', {
  templateUrl: 'components/noteList.html',
  bindings: {
	  label: '<',
	  search: '<'
  },
  controller: function($scope, $http, $modal, serviceLimboMedia) {
	  var ctrl = this;
	  
	  ctrl.items = [];
	  
	  /* paging and sorting */
	  ctrl.ps = {fr: 0, hasMore: false, predicate: 'NAME', dir: 'asc'};
	  
	  ctrl.changeOrder = function(valueOrder) {
		  if(ctrl.ps.predicate == valueOrder) {
				ctrl.ps.dir = ctrl.ps.dir == 'asc' ? 'desc' : 'asc';
			}
			else {
				ctrl.ps.dir = 'asc';
				ctrl.ps.predicate = valueOrder;
			}
			ctrl.loadItems();
		};	  
	  
	  /* loading */
	  ctrl.loadItems = function() {
		  var par = {fr: 0, mr: 0, order: ctrl.ps.predicate, dir: ctrl.ps.dir};

		  if(ctrl.search && ctrl.search.active) {
				par.s = ctrl.search.value;
				$http.get(lmBase.url + 'n/items/search',{params : par})
					.success(function(data) {
						ctrl.items = data;
					}).error(serviceLimboMedia.handleHttpError);
		  }
		  else if(ctrl.label) {
				par.lid = ctrl.label.id;
				$http.get(lmBase.url + 'n/items/list',{params : par})
					.success(function(data) {
						ctrl.items = data;
					}).error(serviceLimboMedia.handleHttpError);
			  
		  }
		  else {
			  ctrl.items = [];
		  }
	  };
	  
	  /* items */
	  ctrl.itemCreateName = '';
	  ctrl.itemCreateContent = '';
	  ctrl.itemCreate = function() {
			var req = {name: ctrl.itemCreateName, content: ctrl.itemCreateContent, labelId: ctrl.label.id};
			$http.post(lmBase.url + 'n/item',req)
				.success(function(data) {
					ctrl.itemCreateName = '';
					ctrl.itemCreateContent = '';
				ctrl.loadItems();
			}).error(serviceLimboMedia.handleHttpError);		
		};
		
		ctrl.itemDelete = function(valueItem) {
			$http.delete(lmBase.url + 'n/item/' + valueItem.id)
				.success(function(data) {
					var idx = ctrl.items.indexOf(valueItem);
					ctrl.items.splice(idx,1);
				}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.itemEdit = function(valueItem) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogNoteEdit.html',
			      controller: 'CtrlDialogNoteEdit',
			      resolve: {
			        itemId: function () {
			          return valueItem.id;
			        }
			      }
			    });
			 
			modalInstance.result.then(
				function () { ctrl.loadItems(); },
			    function () { /* dismissed */ }
			);
		};
		
		ctrl.itemSave = function(valueItem) {
			var req = {name: valueItem.name, content: valueItem.content, labelId: valueItem.label.id};
			$http.post(lmBase.url + 'n/item/' + valueItem.id,req)
				.success(function(data) {
					valueItem.show = false;
			}).error(serviceLimboMedia.handleHttpError);		
		};		
		
		/* settings */
	  ctrl.settings = new Object();
			
	  ctrl.toggleConfig = function() {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogNoteSettings.html',
			      controller: 'CtrlDialogNoteSettings',
			    });
	  	};
		
		/* init */
		ctrl.$onInit = function() {
		  $scope.$watch('$ctrl.label', function(someValue) {
			  ctrl.loadItems();
		  });
		  
		  $scope.$watch('$ctrl.search.active', function(someValue) {
			  ctrl.loadItems();
		  });
		  

		ctrl.settings = serviceLimboMedia.getLocalSettings('notes');
		if(ctrl.settings.colName == null) ctrl.settings.colName = true;
		if(ctrl.settings.colAdded == null) ctrl.settings.colAdded = false;
		  
	  };
	  
  }

});