lm.component('pageHome', {
  templateUrl: 'components/pageHome.html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($modal, serviceLimboMedia) {

	  var ctrl = this;
	  
	  ctrl.settings = null;
	  ctrl.boxes = [];
	  ctrl.rowedBoxes = [];

	  ctrl.rearrange = function() {
		  ctrl.rowedBoxes = [];
		  var secondLevel = null;
		  for(x in ctrl.boxes) {
			  if(x % 4 == 0) {
				  secondLevel = [];
				  ctrl.rowedBoxes.push(secondLevel);
			  }
			  secondLevel.push(ctrl.boxes[x]);
		  }
	  };
	  
	  /* box changing */
	  ctrl.boxUp = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			if(idx < 1) return;
			var tmp = ctrl.boxes[idx];
			ctrl.boxes[idx] = ctrl.boxes[idx - 1];
			ctrl.boxes[idx - 1] = tmp;
			ctrl.rearrange();
			ctrl.stateSave();
		}

	  ctrl.boxDown = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			if(idx >= (ctrl.boxes.length - 1)) return;
			var tmp = ctrl.boxes[idx];
			ctrl.boxes[idx] = ctrl.boxes[idx + 1];
			ctrl.boxes[idx + 1] = tmp;
			ctrl.rearrange();
			ctrl.stateSave();
		}

	  ctrl.boxDelete = function(valueBox) {
			var idx = ctrl.boxes.indexOf(valueBox);
			ctrl.boxes.splice(idx,1);
			ctrl.rearrange();
			ctrl.stateSave();
	  }
	  
	  ctrl.createBoxCallback = function(valueBox) {
		  ctrl.boxes.push(valueBox);
		  ctrl.rearrange();
		  ctrl.stateSave();
	  }
	  
	  ctrl.boxNew = function() {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogHomeNewbox.html',
			      controller: 'CtrlDialogHomeNewBox',
			      resolve: {
			        createBoxCallback: function () {
			          return ctrl.createBoxCallback;
			        }
			      }
			    });
			 
			modalInstance.result.then(
			    function () { /* no ok */ },
				function () {
					ctrl.rearrange();
					ctrl.stateSave();
				}
			);
	  }
	  
	  /* settings */
	  ctrl.stateSave = function() {
		  serviceLimboMedia.saveRemoteSettings();
	  }
	  
	  ctrl.init = function() {
		  ctrl.settings = serviceLimboMedia.getRemoteSettings();
		  if(ctrl.settings.headline == null) {
				ctrl.settings.headline = 'Welcome to your personal LimboMedia Homepage';
		  }
			if(ctrl.settings.boxes == null) {
				ctrl.settings.boxes = [];
				ctrl.boxes = ctrl.settings.boxes;
				
				var box = new Object();
				box.type = 'newsBox';
				box.name = 'LimboMedia News';
				ctrl.boxes.push(box);
			}
			else {
				ctrl.boxes = ctrl.settings.boxes;
			}

			ctrl.rearrange();
	  }
	  
	  ctrl.init();
  }
});