lm.component('pageLink', {
  templateUrl: 'components/pageLink.html',
  bindings: {
  },
  controller: function(serviceLimboMedia, $http, $rootRouter, $timeout) {
	  var ctrl = this;
	  ctrl.status = 'P_LINK_PROCESSING';
	  ctrl.params = {};
	  
	  ctrl.doForward = function() {
		  $rootRouter.navigate(['FilesAndMedia', {id: ctrl.params.resId}]);
	  };
	  
	  ctrl.doToken = function() {
		  var req = {username: 'guest', password: ctrl.params.token};
		  $http.post(lmBase.url + 'user/login',req)
		  	.success(function(data) {
		  		ctrl.status = 'P_LINK_OK';
		  		serviceLimboMedia.setUser(data);
		  		ctrl.doForward();
		  	})
		  	.error(function(data, status) {
		  		ctrl.status = 'P_LINK_FAIL';
		  		console.log(data);
		  		console.log(status);
		  	});
	  };
	  
	  ctrl.$routerOnActivate = function(next) {
		  ctrl.params.resType = next.params.resType;
		  ctrl.params.resId = next.params.resId;
		  ctrl.params.token = next.params.token;

		  if(ctrl.params.resType && ctrl.params.resId && ctrl.params.token) {
			  $timeout(ctrl.doToken, 2000);
		  }
		  else {
			  ctrl.status = 'P_LINK_INVALID';
		  }
	  };
	  
  }
});