lm.component('pageSetUser', {
  templateUrl: 'components/pageSetUser.html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($scope, $http, serviceLimboMedia, serviceNotification, serviceUpload) {
	  var ctrl = this;
	  
	  /* user details */
	  ctrl.user = serviceLimboMedia.userdetails.user;

	  /* password change */
	  ctrl.pwchange = {old: '', neu: ''};
	  ctrl.changePassword = function() {
		  var req = {passwordOld: ctrl.pwchange.old, passwordNew: ctrl.pwchange.neu};
			
			$http.post(lmBase.url + 'user/user', req)
				.success(function(data) { serviceNotification.ok('MSG_RELOGIN'); })
				.error(serviceLimboMedia.handleHttpError);			
		}
	  
	  /* language change */
	  ctrl.languages = [];
	  ctrl.language = ctrl.user.language;
  
	  ctrl.languageChange = function() {
			var req = {language: ctrl.language.code};
			
			$http.post(lmBase.url + 'user/user', req)
				.success(function(data) { serviceLimboMedia.changeLang(ctrl.language.code); })
				.error(serviceLimboMedia.handleHttpError);			
		};
		
		$http.get(lmBase.url + 'system/info')
			.success(function(data) {
				ctrl.languages = data.languages;
				for(x in data.languages) {
					var it = data.languages[x];
					if(it.code == ctrl.user.language) {
						ctrl.language = it;
					}
				}
			}).error(serviceLimboMedia.handleHttpError);		
		
		/* local settings (startpage, video) */
		ctrl.settings = null;
		ctrl.availablePages = ['HOME', 'FILEMEDIA', 'BOOKMARKS', 'TODOS', 'NOTES', 'IOT'];
		ctrl.videoApproaches = ['DEFAULT','P360','P720','P1080'];
		
		ctrl.changeSettings = function() {
			serviceLimboMedia.saveRemoteSettings();
		}

		
	/* Backup & Restore */
		/* Functions for direct JS calls (non-angular) */
		ctrl.onFileSelect = function(element) {
			$scope.$apply(function() {
				var files = [];
				for(x in element.files) {
					var el = element.files[x];
					if(el instanceof File) {
						files.push(el);
					}
				};
				/* let upload service manage this */
				serviceUpload.uploadFiles(files,lmBase.url + 'port/import', true, {});
			});	
		};
		
		ctrl.init = function() {
			ctrl.settings = serviceLimboMedia.getRemoteSettings();
			if(ctrl.settings.initialPage == null) ctrl.settings.initialPage = 'HOME';
			if(ctrl.settings.videoApproach == null) ctrl.settings.videoApproach = 'DEFAULT';
		}
		
		ctrl.init();
  }
});