lm.component('pageSysConsole', {
  templateUrl: 'components/pageSysConsole.html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($scope, $http, serviceLimboMedia, serviceNotification) {
	  var ctrl = this;
	  
		ctrl.ws = null;
		ctrl.connected = false;
		ctrl.content = "";
		ctrl.command = "";
		
		ctrl.clear = function() {
			ctrl.content = "";
			ctrl.command = "";
		}
		
		ctrl.connect = function() {
			ctrl.ws = new WebSocket(lmBase.urlSock + "wsapi/console");

			ctrl.ws.onopen = function() {
				$scope.$apply(function() {
					serviceNotification.ok("MSG_CON_CONNECTED");
					ctrl.clear();
					ctrl.connected = true;
				});
			};

			ctrl.ws.onclose = function(message) {
				$scope.$apply(function() {
					if(1000 == message.code)
						serviceNotification.ok("MSG_CON_DISC_FINE");
					else
						serviceNotification.errorParamed("MSG_CON_DISC_FAIL",[message.code,message.reason]);

					ctrl.connected = false;
				});
			};
			
			ctrl.ws.onerror = function (error) {
				$scope.$apply(function() {
					// dont care and handle with onclose.
					// trycatch around new websocket doenst work so every error will lead to close.
					// ctrl.connected = false;
				});
			};

			ctrl.ws.onmessage = function (message) {
				$scope.$apply(function() {
					ctrl.content += message.data + "\n";
					ctrl.scrolldown();
				});
			};
		}
		
		ctrl.scrolldown = function() {
			var area = document.getElementById("consoleout");
			area.scrollTop = area.scrollHeight;
		}
		
		ctrl.disconnect = function() {
			ctrl.connected = false;
			if(ctrl.ws != null) ctrl.ws.close(1000, "No reason");
		}
		
		ctrl.enter = function() {
			ctrl.content += ">> " + ctrl.command + "\n";
			ctrl.scrolldown();
			ctrl.ws.send(ctrl.command);
			ctrl.command = "";
		}
		
		ctrl.keypress = function($event) {
			if($event.keyCode == 13) ctrl.enter();
		}
		
		$scope.$on('$destroy', function() {
			ctrl.disconnect();
		});

  }
});