lm.component('pageSysFileMedia', {
  templateUrl: 'components/pageSysFileMedia.html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, $modal, serviceLimboMedia, serviceNotification) {
	  var ctrl = this;
	  
		ctrl.defaultmediaconverter = new Object();

		ctrl.availableImageLayouts = ['THUMB_S','THUMB_M','THUMB_L','XS','S','M','L','XL'];
		ctrl.availableAudioStandards = ['WEBM_VORBIS','MP3'];
		ctrl.availableSubtitleCodecs = ['SUBRIP','WEBVTT'];
		ctrl.availableVideoStandards = ['WEBM','MP4'];
		ctrl.availableVideoLayouts = ['P360','P720','P1080'];
		ctrl.imageLayouts = new Array();
		ctrl.audioStandards = new Array();
		ctrl.videoStandards = new Array();
		ctrl.videoLayouts = new Array();
		ctrl.subtitleCodecs = new Array();

		ctrl.loadDefaultMediaConverter = function() {
			$http.get(lmBase.url + 'fileConfig/mediaConverter')
				.success(function(data) {
					ctrl.defaultmediaconverter = data;
					lmBase.multiSelectionInit(ctrl.imageLayouts,ctrl.availableImageLayouts,ctrl.defaultmediaconverter.imageLayouts);
					lmBase.multiSelectionInit(ctrl.audioStandards,ctrl.availableAudioStandards,ctrl.defaultmediaconverter.audioStandards);
					lmBase.multiSelectionInit(ctrl.videoStandards,ctrl.availableVideoStandards,ctrl.defaultmediaconverter.videoStandards);
					lmBase.multiSelectionInit(ctrl.videoLayouts,ctrl.availableVideoLayouts,ctrl.defaultmediaconverter.videoLayouts);
					lmBase.multiSelectionInit(ctrl.subtitleCodecs,ctrl.availableSubtitleCodecs,ctrl.defaultmediaconverter.subtitleCodecs);
				}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.saveDefaultMediaConverter = function() {
			ctrl.defaultmediaconverter.imageLayouts = lmBase.multiSelectionGetSelected(ctrl.imageLayouts);
			ctrl.defaultmediaconverter.audioStandards = lmBase.multiSelectionGetSelected(ctrl.audioStandards);
			ctrl.defaultmediaconverter.videoStandards = lmBase.multiSelectionGetSelected(ctrl.videoStandards);
			ctrl.defaultmediaconverter.videoLayouts = lmBase.multiSelectionGetSelected(ctrl.videoLayouts);
			ctrl.defaultmediaconverter.subtitleCodecs = lmBase.multiSelectionGetSelected(ctrl.subtitleCodecs);
			
			$http.post(lmBase.url + 'fileConfig/mediaConverter',ctrl.defaultmediaconverter)
			.success(function(data) {
				serviceNotification.ok('MSG_SAVED');
				ctrl.loadDefaultMediaConverter();
			}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.fssync = new Object();

		ctrl.loadFssync = function() {
			$http.get(lmBase.url + 'fileConfig/filesystemSynchronization')
				.success(function(data) {
					ctrl.fssync = data;
				}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.saveFssync = function() {
			$http.post(lmBase.url + 'fileConfig/filesystemSynchronization', ctrl.fssync)
			.success(function(data) { 
				serviceNotification.ok('MSG_SAVED');
				ctrl.loadFssync();
			}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.deleteConvertedImages = function() {
			$http.post(lmBase.url + 'fileConfig/deleteConvertedImages')
				.success(function(data) {
					serviceNotification.ok('MSG_JOB_STARTED');
				})
				.error(serviceLimboMedia.handleHttpError)
			;
		};
		
		ctrl.deleteConvertedAudios = function() {
			$http.post(lmBase.url + 'fileConfig/deleteConvertedAudios')
				.success(function(data) {
					serviceNotification.ok('MSG_JOB_STARTED');
				})
				.error(serviceLimboMedia.handleHttpError)
			;
		};
		
		ctrl.deleteConvertedVideos = function() {
			$http.post(lmBase.url + 'fileConfig/deleteConvertedVideos')
				.success(function(data) {
					serviceNotification.ok('MSG_JOB_STARTED');
				})
				.error(serviceLimboMedia.handleHttpError)
			;
		};
		
		ctrl.loadFssync();	
		ctrl.loadDefaultMediaConverter();

  }
});