lm.component('pageSysStats', {
  templateUrl: 'components/pageSysStats.html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, serviceLimboMedia) {
	  var ctrl = this;
	  
	  ctrl.users = [];
		
	  ctrl.toggleDetails = function(valUser) {
			valUser.showDetails = (valUser.showDetails == null) ? "yes" : null;
	  };
		
	  ctrl.loadUsers = function() {
			$http.get(lmBase.url + 'user/users')
				.success(function(data) {
					ctrl.users = data;
					for(y in ctrl.users) {
						ctrl.loadStats(ctrl.users[y]);
					}
				}).error(serviceLimboMedia.handleHttpError);
		};	
		
		ctrl.loadStats = function(usr) {
			ctrl.formats = null;
			ctrl.stats = null;
			ctrl.overall = null;

			$http.get(lmBase.url + 'stats/stats/' + usr.id,{target: usr})
				.success(function(data, status, headers, config) {
					var overall = new Object();
					overall.size = 0;
					overall.items = 0;
					
					for(x in data) {
						var dat = data[x];
						dat.hasDetails = false;
						overall.size += dat.sizeSum;
						overall.items += dat.count;
					}
					config.target.stats = data;
					config.target.overall = overall;
				}).error(serviceLimboMedia.handleHttpError);	
		};
		
		ctrl.loadUsers();  

  }
});