lm.component('pageSysUserMgmt', {
  templateUrl: 'components/pageSysUserMgmt.html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, $modal, serviceLimboMedia) {
	  var ctrl = this;
	  
		ctrl.users = new Array();
		
		ctrl.loadUsers = function() {
			$http.get(lmBase.url + 'userAdmin/users')
				.success(function(data) {
					ctrl.users = data;
				}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.userCreate = function() {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogUserCreate.html',
			      controller: 'CtrlDialogUserCreate'
			    });
			modalInstance.result.then(ctrl.loadUsers, function () { /* dismissed */ });
		};
		
		ctrl.userEdit = function(valueUser) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogUserEdit.html',
			      controller: 'CtrlDialogUserEdit',
			      resolve: {
				        item: function () {
				          return valueUser;
				        }
				      }
			    });
			modalInstance.result.then(ctrl.loadUsers, function () { /* dismissed */ });
		};
		
		ctrl.userDelete = function(valueUser) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogUserDelete.html',
			      controller: 'CtrlDialogUserDelete',
			      resolve: {
				        item: function () {
				          return valueUser;
				        }
				      }
			    });
			modalInstance.result.then(ctrl.loadUsers, function () { /* dismissed */ });
		};	
		
		ctrl.loadUsers();

  }
});