lm.component('pageTodo', {
  templateUrl: 'components/pageTodo.html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, $modal, serviceLimboMedia) {
	  var ctrl = this;
	  
	  ctrl.search = {active: false, value: ''};
	  ctrl.predicate = 'NAME';
	  ctrl.dir = 'asc';
	  ctrl.pageSizes = [10,20,50,100,200,500,1000,100000];

	  /* LabelWithTodos in normal view */
	  ctrl.itemsAIO = [];
	  /* Todos in search view */
	  ctrl.itemsSearch = [];

	  ctrl.clearItems = function() {
		  ctrl.itemsAIO = [];
		  ctrl.itemsSearch = [];
	  }

	  ctrl.loadItems = function() {
		  ctrl.clearItems();
			
			if(ctrl.search.active) {
				var getparams = new Object();
				getparams.order = ctrl.predicate;
				getparams.dir = ctrl.dir;
				getparams.s = ctrl.search.value;
				
				$http.get(lmBase.url + 't/items/search',{params : getparams})
					.success(function(data) {
						ctrl.itemsSearch = data;
					}).error(serviceLimboMedia.handleHttpError);
			}
			else {
				$http.get(lmBase.url + 't/items/allWithLabel')
				.success(function(data) {
					ctrl.itemsAIO = data;
				}).error(serviceLimboMedia.handleHttpError);
			}
		};
		
		ctrl.changeOrder = function(valueOrder) {
			if(ctrl.predicate == valueOrder) {
				ctrl.dir = ctrl.dir == 'asc' ? 'desc' : 'asc';
			}
			else {
				ctrl.dir = 'asc';
				ctrl.predicate = valueOrder;
			}
			ctrl.loadItems();
		};
		
		/* label stuff */
		ctrl.inputLabelCreate = '';

		ctrl.labelCreate = function() {
			$http.post(lmBase.url + 't/label',{name: ctrl.inputLabelCreate})
				.success(function(data) {
					ctrl.inputLabelCreate = '';
					ctrl.loadItems();
				}).error(serviceLimboMedia.handleHttpError);		
		};

		ctrl.labelOnDelete = function(labelWithItems) {
			var idx = ctrl.itemsAIO.indexOf(labelWithItems);
			ctrl.itemsAIO.splice(idx,1);
		};

		
		/* todo stuff */
		ctrl.itemCreate = function(valueLabel, valueName) {
			$http.post(lmBase.url + 't/item',{name: valueName, labelId: valueLabel.id})
			.success(function(data) {
				ctrl.loadItems();
			}).error(serviceLimboMedia.handleHttpError);
		};


		/* SETTINGS */
		ctrl.settings = new Object();

		ctrl.toggleConfig = function() {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogTodoSettings.html',
			      controller: 'CtrlDialogTodoSettings',
		    });
		};
		
		ctrl.settings = serviceLimboMedia.getLocalSettings('todos');
		ctrl.loadItems();
		
  }
});