lm.component('sidebarLabel', {
  templateUrl: 'components/sidebarLabel.html',
  bindings: {
	  prefix: '<',
	  onItemSelect: '&'
  },
  controller: function($http,$modal,serviceLimboMedia) {
	  var ctrl = this;
	  
	  ctrl.item = null;
	  ctrl.items = [];
	  
	  ctrl.userdetails = serviceLimboMedia.getUserdetails();
	  
	  ctrl.loadItems = function() {
		  $http.get(lmBase.url + ctrl.prefix + '/labels/all')
		  	.success(function(data) {
		  		ctrl.items = data;
		  		
		  		if(ctrl.items.length > 0) {
		  			ctrl.selectItem(ctrl.items[0]);
		  		}
			}).error(serviceLimboMedia.handleHttpError);
	  };

	  ctrl.selectItem = function(valueItem) {
		  if(ctrl.item != null) {
			  if(ctrl.item == valueItem) return;
			  ctrl.item.classActive = '';
		  }
		  ctrl.item = valueItem;
		  ctrl.item.classActive = 'active';
		  ctrl.onItemSelect({selectedItem: ctrl.item});
	  }
	  
	  ctrl.createItemName = '';
	  ctrl.createItem = function() {
		  $http.post(lmBase.url + ctrl.prefix + '/label',{name: ctrl.createItemName})
		  		.success(function(data) {
		  			ctrl.createItemName = '';
		  			ctrl.loadItems();
		  		}).error(serviceLimboMedia.handleHttpError);		
	  }
	  
	  
	  ctrl.itemDelete = function(valueItem) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogLabelDelete.html',
			      controller: 'CtrlDialogLabelDelete',
			      resolve: {
			        label: function () { return valueItem; },
					prefix: function () { return ctrl.prefix; }
			      }
			    });
			modalInstance.result.then(
				function () { ctrl.loadItems(); },
			    function () { /* dismissed */ });
	  };
	  
	  ctrl.itemEdit = function(valueLabel) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogLabelEdit.html',
			      controller: 'CtrlDialogLabelEdit',
			      resolve: {
			        label: function () { return valueLabel; },
				    url: function () { return lmBase.url + ctrl.prefix + '/label/' + valueLabel.id; }
			      }
			    });
			 
			modalInstance.result.then(
				function () { ctrl.loadItems(); },
			    function () { }
			);
		};	
		
		ctrl.itemShare = function(valueItem) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogShare.html',
			      controller: 'CtrlDialogShare',
			      resolve: {
			        user: function () { return valueItem.x.user; },
				    url: function () { return lmBase.url + ctrl.prefix + '/label/' + valueItem.id + '/shares'; }
			      }
			    });
			 
			modalInstance.result.then(
				function () { ctrl.loadItems(); },
			    function () { ctrl.loadItems(); }
			);
		};	  
		
	  ctrl.$onInit = function() {
		  ctrl.loadItems();
	  };
	  
  }
});