lm.component('todoBox', {
	templateUrl: 'components/todoBox.html',
	bindings: {
		item: '<',
		afterDelete: '&'
	},
	controller: function($http, $modal, serviceLimboMedia) {
		var ctrl = this;
	  
		ctrl.userdetails = serviceLimboMedia.getUserdetails();
		
		/* label stuff */
		ctrl.labelDelete = function(valueLabel) {
			var modalInstance = $modal.open({
				templateUrl: 'dialogs/dialogLabelDelete.html',
				controller: 'CtrlDialogLabelDelete',
			      resolve: {
			        label: function () { return valueLabel; },
			        prefix: function () { return 't/'; }
			      }
			    });
			modalInstance.result.then(
				function () { ctrl.afterDelete(ctrl.item); },
				function () { /* dismissed */ }
			);
		};
		
		ctrl.labelEdit = function(valueLabel) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogLabelEdit.html',
			      controller: 'CtrlDialogLabelEdit',
			      resolve: {
			    	  label: function () { return valueLabel; },
			    	  url: function () { return lmBase.url + 't/label/' + valueLabel.id; }
			      }
			    });
			 
			modalInstance.result.then(
					function () { ctrl.labelReload(); }, function () { }
			);
		};
		
		ctrl.labelShare = function(valueLabel) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogShare.html',
			      controller: 'CtrlDialogShare',
			      resolve: {
			        user: function () { return valueLabel.x.user; },
				    url: function () { return lmBase.url + 't/label/' + valueLabel.id + '/shares'; }
			      }
			    });
			 
			modalInstance.result.then(
				function () { ctrl.labelReload(); }, function () { }
			);
		};
		
		ctrl.labelReload = function() {
			$http.get(lmBase.url + 't/label/' + ctrl.item.label.id)
					.success(function(data) {
						ctrl.item.label = data;
					}).error(serviceLimboMedia.handleHttpError);
		};
		
		/* item stuff */
		ctrl.itemToggle = function(valueItem) {
			$http.post(lmBase.url + 't/item/' + valueItem.id + '/toggle',!valueItem.done)
				.success(function(data) {
					valueItem.done = !valueItem.done;
				}).error(serviceLimboMedia.handleHttpError);		
		};
		
		ctrl.itemDelete = function(valueItem) {
			$http.delete(lmBase.url + 't/item/' + valueItem.id)
				.success(function(data) {
					var idx = ctrl.item.items.indexOf(valueItem);
					ctrl.item.items.splice(idx,1);
				}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.itemEdit = function(valueItem) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogTodoEdit.html',
			      controller: 'CtrlDialogTodoEdit',
			      resolve: {
			        itemId: function () {
			          return valueItem.id;
			        }
			      }
			    });
			 
			modalInstance.result.then(
				function () { ctrl.itemsReload(); }, function () { /* dismissed */ }
			);
		};
		
		ctrl.itemCreate = function(valueName) {
			$http.post(lmBase.url + 't/item',{name: valueName, labelId: ctrl.item.label.id})
			.success(function(data) {
				ctrl.itemsReload();
			}).error(serviceLimboMedia.handleHttpError);
		};		
		
		ctrl.itemsReload = function() {
			$http.get(lmBase.url + 't/items/list',{params : {lid: ctrl.item.label.id}})
					.success(function(data) {
						ctrl.item.items = data;
					}).error(serviceLimboMedia.handleHttpError);
		};
		
	}
});