lm.component('todoList', {
	templateUrl: 'components/todoList.html',
	bindings: {
		items: '<',
		onReload: '&'
	},
	controller: function($http, $modal, serviceLimboMedia) {
		var ctrl = this;
	  
		ctrl.userdetails = serviceLimboMedia.getUserdetails();
		
		ctrl.itemToggle = function(valueItem) {
			$http.post(lmBase.url + 't/item/' + valueItem.id + '/toggle',!valueItem.done)
				.success(function(data) {
					valueItem.done = !valueItem.done;
				}).error(serviceLimboMedia.handleHttpError);		
		};
		
		ctrl.itemDelete = function(valueItem) {
			$http.delete(lmBase.url + 't/item/' + valueItem.id)
				.success(function(data) {
					var idx = ctrl.items.indexOf(valueItem);
					ctrl.items.splice(idx,1);
				}).error(serviceLimboMedia.handleHttpError);
		};
		
		ctrl.itemEdit = function(valueItem) {
			var modalInstance = $modal.open({
			      templateUrl: 'dialogs/dialogTodoEdit.html',
			      controller: 'CtrlDialogTodoEdit',
			      resolve: {
			        itemId: function () {
			          return valueItem.id;
			        }
			      }
			    });
			 
			modalInstance.result.then(
				function () { ctrl.onReload(); }, function () { /* dismissed */ }
			);
		};		
		
	}
});