/* ===================== */
/* = CONTROLER GENERAL = */
/* ===================== */

lm.controller('CtrlSidebar', ['$scope', 'serviceSidebar', function($scope, serviceSidebar) {
	$scope.state = serviceSidebar.state;
}]);

lm.controller('CtrlMedia', ['$scope', '$http', 'serviceNotification', 'serviceLimboMedia', 'serviceMediaPlayer', 'serviceFullscreen', function($scope, $http, serviceNotification, serviceLimboMedia, serviceMediaPlayer, serviceFullscreen) {
	$scope.state = serviceMediaPlayer.state;
	$scope.fsState = serviceFullscreen.state;
	$scope.pl = serviceMediaPlayer.pl;

	$scope.toggleShow = function() {
		serviceMediaPlayer.toggleShow();
	};

	$scope.stopclose = function() {
		serviceMediaPlayer.stop();
		serviceMediaPlayer.toggleShow();
	};
	
	$scope.onVolumeChange = function($event,refdivid) {
		serviceMediaPlayer.onVolumeChange($event,refdivid);
	}
	
	$scope.onPositionChange = function($event,refdivid) {
		serviceMediaPlayer.onPositionChange($event,refdivid);
	}
	
	$scope.onPlayPause = function() {
		serviceMediaPlayer.playPause();
	}
	
	$scope.onReset = function() {
		serviceMediaPlayer.playReset();
	}
	
	$scope.onFormatChange = function(format) {
		serviceMediaPlayer.changeFormat(format);
	};
	
	$scope.onAudioStreamChange = function(as) {
		serviceMediaPlayer.changeAudioStream(as);
	};
	
	$scope.onSubStreamChange = function(ss) {
		serviceMediaPlayer.changeSubStream(ss);
	};
	
	$scope.onToggleFullscreen = function() {
		serviceMediaPlayer.toggleFullscreen();
	};
	
	/* controls */
	$scope.showControls = false;
	
	$scope.onControlsShow = function(show) {
		$scope.showControls = show;
	};
	
	$scope.onVideoClick = function() {
		$scope.showControls = !$scope.showControls;
	};

	$scope.onVideoEncode = function(valueFile, valueFormat) {
		var req = {standard: valueFormat.standard, layout: valueFormat.layout};
		$http.post(lmBase.url + 'f/video/' + valueFile.id + '/encode',req)
			.success(function(data) { serviceNotification.ok('MSG_JOB_STARTED'); })
			.error(serviceLimboMedia.handleHttpError);
	};

}]);
