/* ======================== */
/* = MODULE configuration = */
/* ======================== */
var lm = angular.module('lm', ['ngComponentRouter', 'ngSanitize', 'pascalprecht.translate', 'ui.bootstrap']);

lm.config(['$httpProvider', function($httpProvider) {

	$httpProvider.defaults.headers.post = {
		'Content-Type' : 'application/json',
		'LM-csrf': 'yeah'
	};

	httpCfgText = {
		headers: { 'Content-Type' : 'text/plain' }
	};

}]);


lm.config(['$translateProvider', function ($translateProvider) {
  
  $translateProvider.useStaticFilesLoader({
	prefix: 'i18n/',
	suffix: '.json'
  });
  $translateProvider.fallbackLanguage('en');
  $translateProvider.preferredLanguage('en');
  $translateProvider.useSanitizeValueStrategy('sanitizeParameters');
}]);

lm.config(function($locationProvider) {
	  $locationProvider.html5Mode(false);
});

lm.value('$routerRootComponent', 'lmApp');

lm.filter('lmDate', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.timestampToDate(input);
	};
});

lm.filter('lmDateTime', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.timestampToDateTime(input);
	};
});
lm.filter('lmSize', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.niceSize(input);
	};
});
lm.filter('lmDuration', function() {
	return function(input, uppercase) {
		input = input || '';
	    return lmBase.secondsToString(input);
	};
});

lm.filter('lmAudioCover', function() {
	return function(input, uppercase) {
		if(input == null || !input.hasCover) {
			return 'img/logo_bigbig.png';
		}
		else {
			return lmBase.url + 'f/streamAudioCover/' + input.id;
		}
	};
});
