lm.factory('serviceFullscreen', ['$rootScope', '$http', 'serviceNotification', 'serviceLimboMedia', function($rootScope, $http, serviceNotification, serviceLimboMedia) {
	var service = new Object();
	
	service.state = new Object();
	service.state.fullscreen = false;
	service.state.aspect = screen.width / screen.height;

	service.refreshScreenAspect = function() {
		$rootScope.$apply(function() {
			service.state.aspect = screen.width / screen.height;
		});
	};
	window.addEventListener('orientationchange', service.refreshScreenAspect);

	service.refreshFullscreen = function() {
		$rootScope.$apply(function() {
			service.state.fullscreen = lmBase.isFullscreen();
		});
	};
	document.addEventListener("fullscreenchange", service.refreshFullscreen);
	document.addEventListener("webkitfullscreenchange", service.refreshFullscreen);
	document.addEventListener("mozfullscreenchange", service.refreshFullscreen);
	document.addEventListener("MSFullscreenChange", service.refreshFullscreen);	
	
	service.onToggleFullscreen = function(fsElement) {
		lmBase.toggleFullscreen(!lmBase.isFullscreen(),fsElement);
	};
	
	/* destructor
	$scope.$on('$destroy', function destroy() {
		document.removeEventListener("fullscreenchange", $scope.refreshFullscreen);
		document.removeEventListener("webkitfullscreenchange", $scope.refreshFullscreen);
		document.removeEventListener("mozfullscreenchange", $scope.refreshFullscreen);
		document.removeEventListener("MSFullscreenChange", $scope.refreshFullscreen);
		window.removeEventListener("orientationchange", $scope.refreshScreenAspect);
	});
	 */
	
	return service;
}]);
