lm.factory('serviceNotification', [ '$timeout', '$translate', function($timeout, $translate) {
	var service = new Object();
	
	service.ok = function(msgKey) {
		$translate(msgKey).then(function (translation) {
			$.notify(translation, "success");
		});
	};
	
	service.error = function(msgKey) {
		$translate(msgKey).then(function (translation) {
			$.notify(translation, "error");
		});
	};

	service.errorParamed = function(msgKey,params) {
		$translate(msgKey).then(function (translation) {
			var msg = translation;
			for(x in params) {
				msg = msg.replace("{" + x + "}", params[x]);
			}
			$.notify(msg, "error");
		});
	};
	
	// "info" and "warn" not required atm
	service.httpError = function(responseText) {
		var injson = angular.fromJson(responseText);
		service.handleLimboError(injson);
	};

	service.handleLimboError = function(data) {
		$translate(['ERROR', data.key]).then(function(trans) {
			var msg = trans[data.key];
			
			for(x in data.params) {
				msg = msg.replace("{" + x + "}", data.params[x]);
			}
			$.notify(msg, "error");
  		});
	};

	return service;
}]);
